package bean;

import bean.annotation.Property;
import utils.Converter;
import utils.Utils;

import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.List;

/**
 * User: huojun
 * Date: 6-Sep-2006
 * Time: 10:41:55 AM
 */
public class BeanUtils {

    public static <T> List<T> rsToList(ResultSet rs, Class<T> theClass) throws Exception {
        List<T> c = new ArrayList<T>();
        ResultSetMetaData metaData = rs.getMetaData();
        while (rs.next()) {
            if (!theClass.equals(String.class) && !theClass.isPrimitive()) {
                T o = theClass.newInstance();
                BeanInfo bi = Introspector.getBeanInfo(theClass);
                PropertyDescriptor[] fields = bi.getPropertyDescriptors();
//                Arrays.sort(fields, new Comparator<PropertyDescriptor>() {
//                    public int compare(PropertyDescriptor o1, PropertyDescriptor o2) {
//                        Method w1 = o1.getWriteMethod();
//                        Method w2 = o2.getWriteMethod();
//                        if ( null != w1 && null != w2 ) {
//                            Property a2 = w2.getAnnotation(Property.class);
//                            Property a1 = w1.getAnnotation(Property.class);
//                            return a1 != null && a2 != null ? a1.ordinal() - a2.ordinal() : 0;
//                        } else {
//                            return 0;
//                        }
//                    }
//                });
                for (PropertyDescriptor f : fields) {
                    Method writeMethod = f.getWriteMethod();
                    if (null != writeMethod) {
                        Property a = writeMethod.getAnnotation(Property.class);
                        if (null != a) {
                            try {
                                String mappedName = a.mappedName();
                                int columnIndex = a.ordinal();
                                if (mappedName.length() > 0) {
                                    String value = rs.getString(mappedName);
                                    if (!rs.wasNull()) {
                                        Object args = Converter.fromString(value, f.getPropertyType());
                                        writeMethod.invoke(o, args);
                                    }
                                } else if (columnIndex >= 0 && columnIndex <= metaData.getColumnCount()) {
                                    String strValue = rs.getString(columnIndex);
                                    if (!rs.wasNull()) {
                                        Object args = Converter.fromString(strValue, f.getPropertyType());
                                        writeMethod.invoke(o, args);
                                    }
                                }
                            } catch (Exception e) {
                                Utils.debug("e = " + e);
                            }
                        }
                    }
                }
                c.add(o);
            } else {
                String value = rs.getString(1);
                if (!rs.wasNull()) {
                    Object v = Converter.fromString(value, theClass);
                    T o = theClass.cast(v);
                    if (!c.contains(o)) {
                        c.add(o);
                    }
                }
            }
        }
        rs.close();
        return c;
    }
}
