package bean.annotation;

import dbhelp.db.Column;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;

/**
 * User: huojun
 * Date: 2-Nov-2006
 * Time: 3:15:53 PM
 */
public class AnnotationUtil {
    public static void main(String[] args) throws IntrospectionException {
        BeanInfo info = Introspector.getBeanInfo(Column.class);
        PropertyDescriptor[] pds = info.getPropertyDescriptors();
        for (int i = 0; null != pds && i < pds.length; i++) {
            PropertyDescriptor pd = pds[i];
            if( pd.getName().equals("nullable") ) {
                System.out.println(getString(pd.getReadMethod(), "desc"));
                break;
            }
        }
    }

    public static Boolean getBoolean(Method m, String aName) {
        return (Boolean) getAnnotationValue(m, aName);
    }

    public static Integer getInt(Method m, String aName) {
        return (Integer) getAnnotationValue(m, aName);
    }

    public static String getString(Method m, String aName) {
        return (String) getAnnotationValue(m, aName);
    }

    private static Object getAnnotationValue(Method m, String aName) {
        if( null != m ) {
            Property a = m.getAnnotation(Property.class);
            if ( null != a ) {
                Method[] methods = a.getClass().getMethods();
                for (int i = 0; null != methods && i < methods.length; i++) {
                    Method method = methods[i];
                    if( aName.equals(method.getName()) ) {
                        try {
                            return method.invoke(a);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
        return null;
    }

    public static boolean exposed(PropertyDescriptor pd) {
        Boolean b = getBoolean(pd.getReadMethod(), "expose");
        return null == b || b;
    }

    public static boolean isPassword(PropertyDescriptor pd) {
        Method wm = pd.getWriteMethod();
        if( null != wm ) {
            Property a = wm.getAnnotation(Property.class);
            return a != null && a.password();
        }
        return false;
    }

    public static String getAnotatedEditor(Method m) {
        return getString(m, "editor");
    }

    public static String getPropertyEditorClass(PropertyDescriptor pd) {
        String editor = getAnotatedEditor(pd.getWriteMethod());
        return null == editor ? getAnotatedEditor(pd.getReadMethod()) : editor;
    }
}
