package bean.editor;

import java.awt.*;
import java.beans.*;
import java.util.Vector;

/**
 * User: huojun
 * Date: 7-Sep-2006
 * Time: 3:18:57 PM
 */
public abstract class AbstractEditor implements PropertyEditor {
    protected Object _value;
    protected Vector<PropertyChangeListener> _listener = new Vector<PropertyChangeListener>();
    protected Object _bean;
    protected PropertyDescriptor _propertyDescriptor;
    private boolean _readOnly;

    static {
        PropertyEditorManager.registerEditor(FileHolder.class, FileEditor.class);
    }
    
    public PropertyDescriptor getPropertyDescriptor() {
        return _propertyDescriptor;
    }

    public void setPropertyDescriptor(PropertyDescriptor propertyDescriptor) {
        _propertyDescriptor = propertyDescriptor;
    }

    public Object getBean() {
        return _bean;
    }

    public void setBean(Object bean) {
        _bean = bean;
    }

    public void editConfirm() {
    }
    
    public Object getValue() {
        return _value;
    }

    public void setValue(Object value) {
        _value = value;
    }

    public boolean isPaintable() {
        return false;
    }

    public void paintValue(Graphics gfx, Rectangle box) {

    }

    public String getJavaInitializationString() {
        return null;
    }

    public String getAsText() {
        return _value == null ? null : _value.toString();
    }

    public String[] getTags() {
        return null;
    }

    public Component getCustomEditor() {
        return null;
    }

    public boolean supportsCustomEditor() {
        return false;
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        if( null != listener ) {
            _listener.add(listener);
        }
    }

    protected void notifyListeners(Object oldValue, Object newValue) {
        PropertyChangeListener[] v = _listener.toArray(new PropertyChangeListener[_listener.size()]);
        for (PropertyChangeListener l : v) {
            l.propertyChange(new PropertyChangeEvent(_bean, _propertyDescriptor.getName(), oldValue, newValue));
        }
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        _listener.remove(listener);
    }

    protected Class<?> getType() {
        return getPropertyDescriptor().getPropertyType();
    }

    public boolean isReadOnly() {
        return _readOnly;
    }

    public void setReadonly(boolean readOnly) {
        _readOnly = readOnly;
    }
}
