package bean.editor;

import bean.annotation.Property;
import utils.Utils;
import utils.Config;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * User: huojun
 * Date: 13-Sep-2006
 * Time: 11:20:35 AM
 */
public class ClassNameEditor extends AbstractEditor {

    public void setAsText(String text) throws IllegalArgumentException {
        setValue(text);
    }

    public String[] getTags() {
        List<FileHolder> jars = new ArrayList<FileHolder>();
        // consider the global jar files
        FileHolder[] extensionJars = Config.getConfig().getExtensionJars();
        if( null != extensionJars ) {
            jars.addAll(Arrays.asList(extensionJars));
        }
        try {
            IJarProvider dbJars = (IJarProvider) getBean();
            FileHolder[] dbJarList = dbJars.getJars();
            if( null != dbJarList ) {
                jars.addAll(Arrays.asList(dbJarList));
            }
            ArrayList<String> a = new ArrayList<String>();
            Property extra = getPropertyDescriptor().getWriteMethod().getAnnotation(Property.class);
            Class target = Class.forName(extra.className());
//            Utils.debug("target = " + target);
            FileHolder[] classJars = jars.toArray(new FileHolder[jars.size()]);
            a.addAll(Arrays.asList(Utils.searchClassInJars(classJars, target)));
            String[] defaults = extra.defaultClassNames().split(";");
            for (String aDefault : defaults) {
                if ( aDefault.trim().length() > 0 ) {
                    a.add(aDefault);
                }
            }
            return a.toArray(new String[a.size()]);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return new String[0];
    }

    public String getAsText() throws IllegalArgumentException {
        return (String) getValue();
    }

}