package bean.editor;

import bean.annotation.LabelTag;
import bean.annotation.Property;
import utils.Converter;
import utils.Utils;

/**
 * User: huojun
 * Date: 20-Sep-2006
 * Time: 2:12:07 PM
 */
public class CodeLabelEditor extends AbstractEditor {

    public String getAsText() {
        Property a = getTagDef();
        String v = getValue() == null ? "Unknown" : getValue().toString();
        for (LabelTag t : a.tags()) {
            if (String.valueOf(t.id()).equals(v)) {
                return t.label();
            }
        }
        return "Unknown";
    }

    private Property getTagDef() {
        return getPropertyDescriptor().getWriteMethod().getAnnotation(Property.class);
    }

    public String[] getTags() {
        LabelTag[] labelTags = getTagDef().tags();
        String[] tags = new String[labelTags.length];
        for (int i = 0; i < tags.length; i++) {
            tags[i] = labelTags[i].label();
        }
        return tags;
    }

    public void setAsText(String text) throws IllegalArgumentException {
        LabelTag[] labelTags = getTagDef().tags();
        for (LabelTag labelTag : labelTags) {
//            Utils.debug("labelTag = " + labelTag);
            if (labelTag.label().equals(text)) {
                Class<?> pt = getPropertyDescriptor().getPropertyType();
                setValue(Converter.fromString(String.valueOf(labelTag.id()), pt));
                return;
            }
        }

    }
}
