package bean.editor;

import javax.swing.*;
import java.awt.*;
import java.io.File;

public class FileEditor extends AbstractEditor {
    // the property editor is created multiple times
    // static member to reduce memory cost
    private static MyFileChooser _fileChooser = new MyFileChooser();

    public String getAsText() throws IllegalArgumentException {
        return getValue() == null ? null : getValue().toString();
    }

    public void setAsText(String text) throws IllegalArgumentException {
        _fileChooser.setValue( new FileHolder(text) );
    }

    public Object getValue() {
        return _fileChooser.getValue();
    }

    public void setValue(Object bean) {
        _fileChooser.setValue(bean);
    }

    public Component getCustomEditor() {
        return _fileChooser;
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    private static class MyFileChooser extends JFileChooser {
        private FileHolder _file;

        public MyFileChooser() {
            setSize(500, 400);
            setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
            setDialogType(SAVE_DIALOG);
            setControlButtonsAreShown(false);
        }

        public void setValue(Object path) {
            _file = (FileHolder)path;
            setSelectedFile(_file.getFile());
        }

        public Object getValue() {
            File sf = getSelectedFile();
            if( null != sf ) {
                _file.setFileName(sf.toString());
            }
            return _file;
        }

//        public void editingDone() {
//            // workaround jdk bug
//            if (getUI() instanceof BasicFileChooserUI) {
//                BasicFileChooserUI ui = (BasicFileChooserUI) getUI();
//                ui.getApproveSelectionAction().actionPerformed(null);
//            }
//            // done with work around
//        }
    }
}
