package bean.editor;

import dbhelp.db.Database;
import utils.text.editor.TokenEditor;

import javax.swing.*;
import java.awt.*;

/**
 * User: huojun
 * Date: 24-Oct-2006
 * Time: 9:52:14 AM
 */
public class SQLEditor extends AbstractEditor {
    private static EditorPane _editorPane = new EditorPane();

    public void setAsText(String text) throws IllegalArgumentException {
        _editorPane.setText(text);
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
        TokenEditor editor = _editorPane.getEditor();
        if ( getBean() instanceof Database ) {
            editor.setDatabase((Database) getBean());
        }
        return _editorPane;
    }

    public Object getValue() {
        return _editorPane.getText();
    }

    public void setValue(Object value) {
        _editorPane.setText(value == null ? null : value.toString());
    }

    public String getAsText() {
        return _editorPane.getText();
    }

    private static class EditorPane extends JPanel {
        protected TokenEditor _editor;

        public EditorPane() {
            super(new BorderLayout() );
            _editor = new TokenEditor();
            JScrollPane jsp = new JScrollPane(_editor);
            add(jsp, BorderLayout.CENTER);
            setSize(new Dimension(500, 400));
            setPreferredSize(getSize());
        }


        public TokenEditor getEditor() {
            return _editor;
        }

        public void setText(String text) {
            _editor.setText(text);
        }

        public String getText() {
            return _editor.getText();
        }
    }
}
