package bean.editor;

import java.lang.reflect.Field;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Collection;

/**
 * User: huojun
 * Date: 7-Sep-2006
 * Time: 3:15:27 PM
 */
public class SQLTypeEditor extends AbstractEditor {
    private static String[] _values = null;

    public String[] getTags() {
        if (null == _values) {
            Collection<String> values = new ArrayList<String>();
            Field[] fields = Types.class.getDeclaredFields();
            for (Field f : fields) {
                values.add(f.getName());
            }
            _values = new String[values.size()];
            _values = values.toArray(_values);
        }
        return _values;
    }


    public Object getValue() {
        return super.getValue();
    }

    public String getAsText() {
        Field[] fields = Types.class.getDeclaredFields();
        for (Field f : fields) {
            try {
                if (f.get(null).equals(_value)) {
                    return f.getName();
                }
            } catch (IllegalAccessException e) {
                throw new IllegalArgumentException(e);
            }
        }
        return null;
    }

    public void setAsText(String text) throws IllegalArgumentException {
        Field[] fields = Types.class.getDeclaredFields();
        for (Field f : fields) {
            if (f.getName().equals(text)) {
                try {
                    _value = f.get(null);
                    return;
                } catch (IllegalAccessException e) {
                    throw new IllegalArgumentException(e);
                }
            }
        }
    }
}
