package bean.editor;

import javax.swing.*;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 25, 2006
 * Time: 12:04:01 PM
 */
public class TextEditor extends AbstractEditor {
    private static EditorPane _editorPane = new EditorPane();

    public void setAsText(String text) throws IllegalArgumentException {
        _editorPane.setText(text);
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
        return _editorPane;
    }

    public Object getValue() {
        return _editorPane.getText();
    }

    public void setValue(Object value) {
        _editorPane.setText(value == null ? null : value.toString());
    }

    public String getAsText() {
        return _editorPane.getText();
    }

    private static class EditorPane extends JPanel {
        protected JTextPane _view;

        public EditorPane() {
            super(new BorderLayout() );
            _view = new JTextPane();
            JScrollPane jsp = new JScrollPane(_view);
            add(jsp, BorderLayout.CENTER);
            setSize(new Dimension(500, 400));
            setPreferredSize(getSize());
        }

        public void setText(String text) {
            _view.setText(text);
        }

        public String getText() {
            return _view.getText();
        }
    }

}
