package bean.editor.utils;

import javax.swing.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.*;

/**
 * User: huojun
 * Date: 17-Oct-2006
 * Time: 10:14:37 AM
 */
public class CheckList extends JList {

    public CheckList() {
        this(new DefaultListModel());
    }


    public CheckList(ListModel dataModel) {
        super(dataModel);
        addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                toggle();
            }
        });
        addKeyListener(new KeyAdapter() {
            public void keyTyped(KeyEvent e) {
                if (e.getKeyChar() == ' ') {
                    toggle();
                }
            }
        });
        setCellRenderer(new MyListCellRenderer());
    }


    public void toggle() {
        Object o = getSelectedValue();
        if (o instanceof Item) {
            Item item = (Item) o;
            item.setSelected(!item.isSelected());
            repaint();
        }
    }



    private static class MyListCellRenderer extends JCheckBox implements ListCellRenderer {

        public MyListCellRenderer() {
            super();
            setOpaque(true);
            setBackground(Color.white);
        }

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            setBackground(isSelected ? list.getSelectionBackground() :
                    list.getBackground());
            setForeground(isSelected ? list.getSelectionForeground() :
                    list.getForeground());
            setText(value.toString());
            setSelected(((Item) value).isSelected());

            return this;
        }
    }
}
