package bean.editor.utils;

import utils.Utils;

import javax.swing.*;
import java.util.ArrayList;
import java.util.List;

/**
 * User: huojun
* Date: 17-Oct-2006
* Time: 9:51:33 AM
*/
public class CheckListModel<T> extends AbstractListModel {
    protected List<Item<T>> _list = new ArrayList<Item<T>>();

    public void setData(List<T> data) {
        _list.clear();
        if (null != data) {
            for (T s : data) {
                _list.add(new Item<T>(s));
            }
        }
        fireContentsChanged(this, 0, _list.size() - 1);
    }

    public List<T> getData() {
        List<T> list = new ArrayList<T>();
        for (Item<T> i : _list) {
            Utils.debug(i + " = " + i.isSelected());
            if (i.isSelected()) {
                list.add(i.getValue());
            }
        }
        return list;
    }

    public int getSize() {
        return _list.size();
    }

    public Object getElementAt(int index) {
        return _list.get(index);
    }
}
