package dbhelp.db;

import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 12, 2006
 * Time: 11:43:24 PM
 * To change this template use File | Settings | File Templates.
 */
public interface IDbMeta {
    Database getDatabase();

    List<Catalog> getCatalogs() throws Exception;

    List<Schema> getSchemas() throws Exception;

    List<String> getTableTypes() throws Exception;

    List<Table> getAllTables() throws Exception;

    List<Column> getColumns(Table t) throws Exception;

    List<PrimaryKey> getPrimaryKeys(Table t) throws Exception;

    List<ForeignKey> getForeignKeys(Table t) throws Exception;

    List<Table> getTables(String catalog, String schema, String tableType, String tablePattern) throws Exception;

    String[] getKeywords() throws Exception;

    List<Procedure> getProcedures(String catalog, String schema, String name) throws Exception;

    List<ProcedureColumn> getProcedureColumns(Procedure p) throws Exception;

    List<Function> getFunctions() throws Exception;

    List<Index> getIndexes(Table table) throws Exception;

    List<ForeignKey> getExportedKeys(Table t) throws Exception;

    String getDatabaseProductName() throws Exception;

    String getDatabaseProductVersion() throws Exception;

    String getProcedureSyntax(String queryCmd) throws Exception;

    String getIdentifierQuoteString() throws Exception;

    List<Catalog> getAllCatalogs() throws Exception;
}
