package dbhelp.db;

import bean.annotation.Property;

/**
 * User: huojun
 * Date: 15-Sep-2006
 * Time: 3:07:10 PM
 */
public class ProcedureColumn implements IDBObject, INamedDBObject {
//PROCEDURE_CAT String => procedure catalog (may be null)
    private String _catalog;
//PROCEDURE_SCHEM String => procedure schema (may be null)
    private String _schema;
//PROCEDURE_NAME String => procedure name
    private String _procedureName;
//COLUMN_NAME String => column/parameter name
    private String _name;
//COLUMN_TYPE Short => kind of column/parameter:
    private short _columnType;
//procedureColumnUnknown - nobody knows
//procedureColumnIn - IN parameter
//procedureColumnInOut - INOUT parameter
//procedureColumnOut - OUT parameter
//procedureColumnReturn - procedure return value
//procedureColumnResult - result column in ResultSet
//DATA_TYPE int => SQL type from java.sql.Types
    private int _dataType;
//TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
    private String _typeName;
//PRECISION int => precision
    private int _precision;
//LENGTH int => length in bytes of data
    private int _length;
//SCALE short => scale
    private short _scale;
//RADIX short => radix
    private short _radix;
//NULLABLE short => can it contain NULL.
    private short _nullable;
//procedureNoNulls - does not allow NULL values
//procedureNullable - allows NULL values
//procedureNullableUnknown - nullability unknown
//REMARKS String => comment describing parameter/column
    private String _remarks;

    public ProcedureColumn() {
    }

    public String getCatalog() {
        return _catalog;
    }

    @Property(ordinal = 1)
    public void setCatalog(String catalog) {
        _catalog = catalog;
    }

    public String getSchema() {
        return _schema;
    }

    @Property(ordinal = 2)
    public void setSchema(String schema) {
        _schema = schema;
    }

    public String getProcedureName() {
        return _procedureName;
    }

    @Property(ordinal = 3)
    public void setProcedureName(String procedureName) {
        _procedureName = procedureName;
    }

    public String getName() {
        return _name;
    }

    @Property(ordinal = 4)
    public void setName(String name) {
        _name = name;
    }

    public short getColumnType() {
        return _columnType;
    }

    @Property(ordinal = 5)
    public void setColumnType(short columnType) {
        _columnType = columnType;
    }

    public int getDataType() {
        return _dataType;
    }

    @Property(ordinal = 6, editor = "bean.editor.SQLTypeEditor")
    public void setDataType(int dataType) {
        _dataType = dataType;
    }

    public String getTypeName() {
        return _typeName;
    }

    @Property(ordinal = 7)
    public void setTypeName(String typeName) {
        _typeName = typeName;
    }

    public int getPrecision() {
        return _precision;
    }

    @Property(ordinal = 8)
    public void setPrecision(int precision) {
        _precision = precision;
    }

    public int getLength() {
        return _length;
    }

    @Property(ordinal = 9)
    public void setLength(int length) {
        _length = length;
    }

    public short getScale() {
        return _scale;
    }

    @Property(ordinal = 10)
    public void setScale(short scale) {
        _scale = scale;
    }

    public short getRadix() {
        return _radix;
    }

    @Property(ordinal = 11)
    public void setRadix(short radix) {
        _radix = radix;
    }

    public short getNullable() {
        return _nullable;
    }

    @Property(ordinal = 12)
    public void setNullable(short nullable) {
        _nullable = nullable;
    }

    public String getRemarks() {
        return _remarks;
    }

    @Property(ordinal = 13)
    public void setRemarks(String remarks) {
        _remarks = remarks;
    }

    public String toString() {
        return _name;
    }

    public String getSimpleName() {
        return getName();
    }
}
