package dbhelp.db.model;

import dbhelp.db.Catalog;
import dbhelp.db.Schema;
import dbhelp.db.Database;
import bean.annotation.Property;

/**
 * User: huojun
 * Date: 6-Oct-2006
 * Time: 10:23:18 PM
 */
public class DBFilterObject {
    private String _name;
    private Object[] _filterObjects;
    private Database _database;
    private IDBNode _node;

    public DBFilterObject() {
    }

    public DBFilterObject(String name) {
        _name = name;
    }

    @Property(expose = false)
    public IDBNode getNode() {
        return _node;
    }

    public void setNode(IDBNode node) {
        _node = node;
    }

    public Database getDatabase() {
        return _database;
    }

    @Property( expose = false )
    public void setDatabase(Database database) {
        _database = database;
    }

    public String getName() {
        return _name;
    }

    @Property( editable = false )
    public void setName(String name) {
        _name = name;
    }

    @Property(name = "Filter Objects", desc = "Sepecify the objects to filter the child list")
    public Object[] getFilterObjects() {
        return _filterObjects;
    }

    @Property( editor = "dbhelp.db.model.DBFilterEditor")
    public void setFilterObjects(Object[] filterObjects) {
        _filterObjects = filterObjects;
    }

    public String toString() {
        return _name;
    }

    public boolean accept(String catalog, String schema) {
        boolean ok = false;
        if( null != _filterObjects && _filterObjects.length > 0 ) {
            for(Object o : _filterObjects ) {
                if( o instanceof Catalog ) {
                    Catalog c = (Catalog) o;
                    if( c.getName().equals(catalog) ) {
                        ok = true;
                        break;
                    }
                } else if( o instanceof Schema ) {
                    Schema s = (Schema) o;
                    if(s.getName().equals(schema)) {
                        ok = true;
                        break;
                    }
                }
            }
        } else {
            ok = true;
        }
        return ok;
    }


}
