package dbhelp.db.model;

import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import java.util.List;
import java.util.Vector;

/**
 * User: huojun
 * Date: 6-Sep-2006
 * Time: 11:29:33 AM
 */
public class DBTreeModel implements TreeModel {
    private IDBNode _root;
    private Vector<TreeModelListener> _listeners = new Vector<TreeModelListener>();

    public DBTreeModel(IDBNode root) {
        _root = root;
    }

    public Object getRoot() {
        return _root;
    }

    public Object getChild(Object parent, int index) {
        return dbNode(parent).getChildren().get(index);
    }

    public int getChildCount(Object parent) {
        List<IDBNode> children = dbNode(parent).getChildren();
        return children == null ? 0 : children.size();
    }

    private IDBNode dbNode(Object node) {
        return ((IDBNode) node);
    }

    public boolean isLeaf(Object node) {
        if (node instanceof ILeafControl) {
            ILeafControl l = (ILeafControl) node;
            return l.isLeaf();
        }
        List<IDBNode> children = dbNode(node).getChildren();
        return children == null || children.size() == 0;

    }

    public void valueForPathChanged(TreePath path, Object newValue) {

    }

    public int getIndexOfChild(Object parent, Object child) {
        IDBNode n = (IDBNode) child;
        List<IDBNode> children = dbNode(parent).getChildren();
        return null == children ? 0 : children.indexOf(n);
    }

    public void addTreeModelListener(TreeModelListener l) {
        if (null != l) {
            _listeners.add(l);
        }
    }

    public void removeTreeModelListener(TreeModelListener l) {
        _listeners.remove(l);
    }

    public void fireTreeNodeChange(TreeModelEvent event) {
        TreeModelListener[] v = _listeners.toArray( new TreeModelListener[_listeners.size()]);
        for (TreeModelListener l : v) {
//            l.treeNodesChanged(event);
            l.treeStructureChanged(event);
        }
    }
}
