package dbhelp.db.model.search;

import dbhelp.db.Database;
import dbhelp.db.ForeignKey;
import dbhelp.db.Table;
import utils.Utils;

import java.util.ArrayList;
import java.util.List;

/**
 * User: huojun
 * Date: 13-Oct-2006
 * Time: 12:59:35 PM
 */
public class TableSearcher implements ISearchable {
    private String _tableType;


    public TableSearcher(String tableType) {
        _tableType = tableType;
    }

    public List<SearchResult> find(Object o) {
        List<SearchResult> l = new ArrayList<SearchResult>();
        if (o instanceof Table) {
            Table t = (Table) o;
            Table dummy = new Table();
            Database db = t.getDatabase();
            if (db != null && db.isConnected()) {
                try {
                    List<Table> tables = db.getMetaData().getTables(t.getCatalog(), t.getSchema(), _tableType, null);
                    for (Table table : tables) {
                        ForeignKey[] fks = table.getForeignKeys();
                        for (int i = 0; null != fks && i < fks.length; i++) {
                            ForeignKey fk = fks[i];
                            if (fk.getPkTableName().equalsIgnoreCase(t.getName())) {
                                dummy.setCatalog(fk.getPkTableCatalog());
                                dummy.setSchema(fk.getPkTableSchema());
                                dummy.setName(fk.getPkTableName());
                                if (t.toString().equals(dummy.toString())) {
                                    SearchResult sr = new SearchResult(table);
                                    sr.setDescription("Foreign key reference: " + fk);
                                    l.add(sr);
                                    break;
                                }
                            }
                        }
                    }
                } catch (Exception e) {
                    Utils.debug("TableSearcher.find: " + e);
                }
            }
        }
        return l;
    }


    public String toString() {
        return "Foreign Key References in " + _tableType;
    }
}
