package dbhelp.db.model.search.provider;

import dbhelp.db.Database;
import dbhelp.db.Procedure;
import dbhelp.db.Table;
import dbhelp.db.model.search.ProcedureSearcher;
import dbhelp.db.model.search.TableSearcher;
import utils.IDataCollectorListener;
import utils.Utils;

import java.util.List;

/**
 * User: huojun
* Date: 16-Oct-2006
* Time: 10:58:46 PM
*/
public class TableAndProcedureSearchProvider implements IDataCollectorListener {
    public <T> void collect(Object info, List<T> list, Class<T> type) {
        Database db = null;
        String catalog = null;
        if (info instanceof Table) {
            db = ((Table) info).getDatabase();
            catalog = ((Table) info).getCatalog();
        } else if (info instanceof Procedure) {
            db = ((Procedure) info).getDatabase();
            catalog = ((Procedure) info).getCatalog();
        }
        if (null != db && db.isConnected() ) {
            try {
                if (Utils.hasValue(db.getProcedureSyntaxQuery())) {
                    ProcedureSearcher searcher = new ProcedureSearcher(db.getMetaData().getProcedures(catalog, null, null));
                    T item = type.cast(searcher);
                    list.add(item);
                }
                if ( info instanceof Table ) {
                    List<String> types = db.getMetaData().getTableTypes();
                    for(String tt : types) {
                        TableSearcher ts = new TableSearcher(tt);
                        list.add( type.cast(ts) );
                    }
                }
            } catch (Exception e) {
                Utils.debug("ProjectMain.collect: " + e);
            }
        }
    }
}
