package dbhelp.plugin;

import utils.Utils;

import javax.swing.*;
import javax.swing.text.BadLocationException;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.io.Writer;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 6-Oct-2005
 * Time: 5:36:38 PM
 */
public class LogConsole extends Writer {
    private JTextArea _text;
    private int _maxLines = 5000;

    public LogConsole(JTextArea text) {
        _text = text;
        _text.setEditable(false);
    }

    public long getMaxLines() {
        return _maxLines;
    }

    public void setMaxLines(int maxLines) {
        _maxLines = maxLines;
    }

    public void close() {
    }

    public void flush() {
        _text.setText("");
    }

    public void write(final char cbuf[], final int off, final int len) throws IOException {
        try {
            _text.append(new String(cbuf, off, len));
            int l = _text.getLineCount() - _maxLines;
            if (l > 0) {
                int offset = _text.getLineStartOffset(l);
                _text.replaceRange(null, 0, offset);
            }
            int line = _text.getLineCount() - 1;
            if (line >= 0) {
                int offset = _text.getLineStartOffset(line);
                _text.setCaretPosition(offset);
            }
        } catch (BadLocationException e) {
            Utils.debug(e);
            _text.setText("");
        }
    }

    public Object getPopupSource() {
        return this;
    }

    private static class actionClear extends AbstractAction {
        public actionClear() {
            super("Clear");
        }

        public void actionPerformed(ActionEvent e) {
            LogConsole value = (LogConsole) getValue("object");
            value.flush();
        }
    }
}
