package dbhelp.plugin;

import bean.PropertyChangeMultiCaster;
import dbhelp.db.Database;
import dbhelp.db.Query;
import utils.Config;
import utils.Utils;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * User: huojun
 * Date: 25-Oct-2006
 * Time: 8:38:40 PM
 */
public class QueryEditor extends SQLConsole {
    private Query _query;


    public QueryEditor() {
        super();
        Action saveAction = new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                _query.setSQLScript(_editor.getText());
                PropertyChangeMultiCaster.getInstance().fireChangeEvent(Config.getConfig(), "savedQueries");
            }
        };
        _toolbar1.getActionMap().put("save-query", saveAction);
        ActionMap m = _editor.getActionMap();
        Action runAction = m.get("runsql");
        m.put("runsql", new OverrideRunAction(runAction));
    }

    public Query getQuery() {
        return _query;
    }

    public void setQuery(Query query) {
        _query = query;
        setTitle("Edit Query: " + _query.getName());
        _editor.setText(_query.getSQLScript());
        Database[] databases = Config.getConfig().getDatabases();
        for (int i = 0; null != databases && i < databases.length; i++) {
            Database database = databases[i];
            if (database.getName().equals(_query.getDatabaseName())) {
                _databaseCombo.setSelectedItem(database);
                _databaseCombo.setEnabled(false);
                break;
            }
        }
    }

    private class OverrideRunAction extends AbstractAction {
        protected Action _oldAction;
        public OverrideRunAction(Action oldAction) {
            _oldAction = oldAction;
        }

        public void actionPerformed(ActionEvent e) {
            Object item = _databaseCombo.getSelectedItem();
            if ( item instanceof Database ) {
                _query.setDatabaseName(((Database) item).getName());
                _oldAction.actionPerformed(e);
            } else {
                Utils.message("Select a database first!");
            }
        }
    }
}