package dbhelp.plugin;

import bean.PropertyChangeMultiCaster;
import dbhelp.db.Database;
import dbhelp.plugin.ui.ResultTablePanel;
import utils.Config;
import utils.Utils;

import javax.swing.*;
import java.awt.*;

/**
 * User: huojun
 * Date: 19-Oct-2006
 * Time: 5:05:01 PM
 */
public class SQLConsole extends ResultTablePanel {
    private static int _id = 1;

    public static void main(String[] args) {
        try {
            Config.restore();
        } catch (Exception e) {
            e.printStackTrace();
        }
        JFrame f = new JFrame();
        Container cp = f.getContentPane();
        cp.setLayout(new BorderLayout());
        f.setSize(800, 800);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        cp.add(new SQLConsole(), BorderLayout.CENTER);
        f.setVisible(true);
    }


    public static int getId() {
        return _id++;
    }

    protected void initComponent() {
        super.initComponent();
        _editorView.setVisible( true );
        _splitPane.setDividerLocation(0.0);
        _databaseCombo.setEnabled(true);
        _editor.setDatabase((Database) _databaseCombo.getSelectedItem());
        _editor.requestFocus();
    }

    public static void newSQLConsole() {
        String name = JOptionPane.showInputDialog(Utils.getFrame(), "Console Name", "SQL Console " + getId());
        if( null != name) {
            SQLConsole sqlConsole = new SQLConsole();
            OutputPane outputPane = OutputPane.getOutputPane();
            outputPane.addTab(name, sqlConsole);
            outputPane.setSelectedComponent(sqlConsole);
            PropertyChangeMultiCaster.getInstance().fireChangeEvent(outputPane, "visible");
        }
    }
}
