package dbhelp.plugin.action.portable;

import bean.editor.TabbedBeanEditorPane;
import bean.PropertyChangeMultiCaster;
import dbhelp.plugin.OutputPane;
import utils.SingletonProvider;

import java.awt.*;
import java.awt.event.ActionEvent;

/**
 * User: huojun
 * Date: 2-Nov-2006
 * Time: 4:38:12 PM
 */
public class ActionComplexView extends PortableAction{

    public ActionComplexView() {
        super("Open Detailed View");
    }

    public void actionPerformed(ActionEvent e) {
        OutputPane outputPane = SingletonProvider.getProvider().getOutputPane();
        Component[] components = outputPane.getComponents();
        TabbedBeanEditorPane editor = null;
        for (int i = 0; null != components && i < components.length; i++) {
            Component component = components[i];
            if( component instanceof TabbedBeanEditorPane ) {
                TabbedBeanEditorPane p = (TabbedBeanEditorPane) component;
                if( getUserData().equals(p.getBean())) {
                    editor = p;
                    break;
                }
            }
        }
        if( null == editor ) {
            editor = new TabbedBeanEditorPane();
            editor.setBean( getUserData() );
            outputPane.addTab("Detailed View: " + getUserData().toString(), editor);
        }
        outputPane.setSelectedComponent(editor);
        PropertyChangeMultiCaster.getInstance().fireChangeEvent(outputPane, "visible");
    }
}
