package dbhelp.plugin.action.portable;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 21, 2006
 * Time: 8:22:27 PM
 */
public class ActionGroup extends PortableAction {
    protected List<PortableAction> _actions = new ArrayList<PortableAction>();

    public ActionGroup(String name) {
        super(name);
    }

    public void addAction(PortableAction a) {
        if ( null != a ) {
            _actions.add(a);
        } else {
            throw new IllegalArgumentException("Action can't be null!");
        }
    }

    public void removeAction(PortableAction a) {
        _actions.remove(a);
    }

    public PortableAction[] getActions() {
        return _actions.toArray(new PortableAction[_actions.size()]);
    }

    public void actionPerformed(ActionEvent e) {
        // does nothing
    }

    public void addAll(PortableAction[] actions) {
        for( int i=0; null != actions && i<actions.length; i++ ) {
            addAction(actions[i]);
        }
    }

    public void addAll(Collection<PortableAction> shapeActions) {
        if ( null != shapeActions ) {
            _actions.addAll(shapeActions);
        }
    }

}
