package dbhelp.plugin.action.portable;

import static dbhelp.plugin.action.portable.PopupMenuManager.createMenu;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 23, 2006
 * Time: 11:21:34 AM
 */
public abstract class PopupMouseAdapter extends MouseAdapter {
    public void mouseClicked(MouseEvent e) {
        checkPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
        checkPopup(e);
    }

    public void mousePressed(MouseEvent e) {
        checkPopup(e);
    }

    /**
     * Override this to control the popup
     * @return ture or false
     */
    protected boolean shouldPopup() {
        return true;
    }

    protected void checkPopup(MouseEvent e) {
        if (e.isPopupTrigger() && shouldPopup()) {
            Set<Object> actions = getActionKeys(e);
            if (null != actions && actions.size() > 0 ) {
                JPopupMenu menu = createMenu(e, actions);
                if (null != menu) {
                    menu.show((Component) e.getSource(), e.getX(), e.getY());
                }
            }
        } else {
            handleEvent(e);
        }
    }

    protected void handleEvent(MouseEvent e) {
    }

    protected abstract Set<Object> getActionKeys(MouseEvent e);
}
