package dbhelp.plugin.action.portable;

import javax.swing.*;
import java.awt.event.MouseEvent;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 23, 2006
 * Time: 12:05:41 PM
 */
public abstract class PortableAction extends AbstractAction {
    private static final String USERDATA = "userdata";
    private static final String MOUSEEVENT_SOURCE = "source";

    protected PortableAction() {
    }

    protected PortableAction(String name) {
        super(name);
    }

    public Object getUserData() {
        return getValue(USERDATA);
    }

    MouseEvent getMouseEvent() {
        return (MouseEvent) getValue(MOUSEEVENT_SOURCE);
    }

    void setMouseEvent(MouseEvent e) {
        putValue(MOUSEEVENT_SOURCE, e);
    }

    public void setUserData(Object o) {
        putValue(USERDATA, o);
    }

    public String toString() {
        Object value = getValue("Name");
        return value == null ? super.toString() : value.toString();
    }

}
