package dbhelp.plugin.action.portable;

import dbhelp.db.model.AbstractDBObject;
import dbhelp.db.model.DBTreeModel;
import dbhelp.db.model.IDBNode;
import dbhelp.db.ui.DBTree;

import javax.swing.event.TreeModelEvent;
import java.awt.event.ActionEvent;

import utils.Utils;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 23, 2006
 * Time: 12:04:09 PM
 */
public class RefreshTreeFolder extends PortableAction {
    public RefreshTreeFolder() {
        super("Refresh folder");
    }

    public void actionPerformed(ActionEvent e) {
        DBTree tree = (DBTree) getUserData();
        Object c = tree.getLastSelectedPathComponent();
        if (c instanceof IDBNode) {
            IDBNode dbObject = (IDBNode) c;
            dbObject.refresh();
            DBTreeModel m = (DBTreeModel) tree.getModel();
            m.fireTreeNodeChange(new TreeModelEvent(this, tree.getSelectionPath()));
            while(! (dbObject instanceof AbstractDBObject.ProfileNode) && null != dbObject ) {
                dbObject = dbObject.getParent();
            }
            if (dbObject != null) {
                AbstractDBObject.ProfileNode dbNode = (AbstractDBObject.ProfileNode) dbObject;
                try {
                    dbNode.getDatabase().getResolver().refresh();
                } catch (Exception e1) {
                    Utils.debug("RefreshTreeFolder.actionPerformed: " + e1);
                }
            }
        }
    }
}
