package dbhelp.plugin.action.portable;

import dbhelp.db.Database;

import java.awt.event.ActionEvent;
import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;

import bean.PropertyChangeMultiCaster;
import utils.Config;
import utils.Utils;

import javax.swing.*;

/**
 * User: huojun
 * Date: 12-Oct-2006
 * Time: 9:54:28 AM
 */
public class RemoveDatabaseAction extends PortableAction {
    public RemoveDatabaseAction() {
        super("Remove this database");
    }

    public void actionPerformed(ActionEvent e) {
        Database db = (Database) getUserData();
        if( null != db ) {
            int ret = JOptionPane.showConfirmDialog(Utils.getFrame(), "Are you sure to remove: " + db);
            if ( ret == 0 ) {
                PropertyChangeMultiCaster instance = PropertyChangeMultiCaster.getInstance();
                if ( db.isConnected() ) {
                    db.disconnect();
                }
                Config cfg = Config.getConfig();
                Database[] databases = cfg.getDatabases();
                List<Database> list = new ArrayList<Database>(Arrays.asList(databases));
                list.remove(db);
                try {
                    instance.set(cfg, "databases", list.toArray(new Database[list.size()]));
                } catch (Exception e1) {
                    Utils.error(e1);
                }
            }
        }
    }
}
