package dbhelp.plugin.action.portable;

import bean.editor.ArrayEditor;
import dbhelp.db.Attribute;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.context.Context;
import template.TemplateDescriptor;
import utils.Utils;
import utils.Config;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 22, 2006
 * Time: 8:33:48 PM
 */
public class RunTemplateAction extends PortableAction {
    private TemplateDescriptor _td;
    private Object _target;

    public RunTemplateAction(TemplateDescriptor td) {
        super(td.getName());
        _td = td;
    }

    public Object getTarget() {
        return _target;
    }

    public void setTarget(Object target) {
        _target = target;
    }

    public void actionPerformed(ActionEvent e) {
        try {
            VelocityContext vc = new VelocityContext();
            vc.put("target", getTarget());
            String output = runTemplate(vc);
            Utils.copyToClipboard(output);
            Config cfg = Config.getConfig();
            if (cfg.isShowTemplateInClipboardMessage()) {
                Window aw = FocusManager.getCurrentManager().getActiveWindow();
                Object[] options = {"OK", "Don't tell me again"};
                int ret = JOptionPane.showOptionDialog(aw, "The template output is in the clipboard!", "Message",
                        JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE, null, options, options[0]);
                cfg.setShowTemplateInClipboardMessage(ret == 0);
            }
        } catch (Exception e1) {
            Utils.error(e1);
        }
    }

    public String runTemplate(Context vc) throws Exception {
        List<Attribute> params = new ArrayList<Attribute>();
        for (TemplateDescriptor.TemplateParameter p : _td.getRuntimeParams()) {
            params.add(new Attribute(p.getName(), p.getDefaultValue()));
        }
        if (params.size() > 0) {
            Attribute[] attributes = params.toArray(new Attribute[params.size()]);
            ArrayEditor.editArray(attributes, Attribute.class);
            for (Attribute a : attributes) {
                vc.put("runtime_" + a.getName(), a.getValue());
            }
        }
        return _td.execute(vc);
    }

}
