package dbhelp.plugin.action.portable;

import bean.PropertyChangeMultiCaster;
import bean.editor.EditorDialog;
import dbhelp.db.Database;
import dbhelp.db.model.CatalogFilterEditor;
import utils.Utils;

import java.awt.*;
import java.awt.event.ActionEvent;

/**
 * User: huojun
 * Date: 7-Oct-2006
 * Time: 9:46:07 PM
 */
public class SetCatalogFilterAction extends PortableAction {
    public SetCatalogFilterAction() {
        super("Set Catalog Filter");
    }

    public void actionPerformed(ActionEvent e) {
        Database f = (Database) getUserData();
        if ( !f.isConnected() ) {
            try {
                f.connect();            
            } catch (Exception e1) {
                Utils.error(e1);
                return;
            }
        }
        editFilter(f);
    }

    public static void editFilter(Database f) {
        EditorDialog ed = new EditorDialog((Frame) Utils.getFrame());
        ed.setTitle("Select Catalog(s) - select none to disable filtering");
        CatalogFilterEditor editor = new CatalogFilterEditor();
        editor.setBean(f);
        editor.setValue(f.getCatalogFilter());
        ed.setEditor(editor);
        ed.setVisible(true);
        PropertyChangeMultiCaster c = PropertyChangeMultiCaster.getInstance();
        try {
            c.set(f, "catalogFilter", editor.getValue());
        } catch (Exception e1) {
            Utils.debug("SetCatalogFilterAction.actionPerformed: " + e1);
        }
    }
}
