package dbhelp.plugin.complete.utils;

import javax.swing.table.AbstractTableModel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * User: huojun
 * Date: 14-Sep-2006
 * Time: 10:27:02 AM
 */
public class CompleterModel extends AbstractTableModel {
    protected java.util.List<CompleterItem> _list = new ArrayList<CompleterItem>();
    protected java.util.List<Integer> _index = new ArrayList<Integer>();
    private String _filter = null;

    public CompleterModel() {
    }

    public CompleterModel(List<CompleterItem> list) {
        setList(list);
    }

    public List<CompleterItem > getList() {
        return _list;
    }

    public void setList(Collection<CompleterItem> list) {
        _filter = null;
        _list.clear();
        _list.addAll(list);
//        _index.clear();
        setFilter(_filter);
//        fireTableDataChanged();
    }

    public String getFilter() {
        return _filter;
    }

    public void setFilter(String prefix) {
        _index.clear();
        _filter = prefix;
        if( null != _filter ) {
            String p = _filter.toLowerCase();
            for(int i=0; null != _list && i<_list.size(); i++) {
                if( _list.get(i).toString().toLowerCase().startsWith(p) ) {
                    _index.add(i);
                }
            }
        }
        fireTableDataChanged();
    }

    public int getRowCount() {
        return null == _filter ? (null == _list ? 0 : _list.size()) : _index.size();
    }

    public int getColumnCount() {
        return 3;
    }

    public CompleterItem getItem(int rowIndex) {
        return _list.get(indexToRow(rowIndex));
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        CompleterItem ci = _list.get(indexToRow(rowIndex));
        if( columnIndex == 0 ) {
            return ci.getIconIndex();
        } else if( columnIndex == 1 ) {
            return ci.toString();
        } else {
            return ci.getDescription();
        }
    }

    private int indexToRow(int rowIndex) {
        return null == _filter ? rowIndex : _index.get(rowIndex);
    }

}
