package dbhelp.plugin.idea;

import com.intellij.openapi.components.ApplicationComponent;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.openapi.fileEditor.*;
import com.intellij.openapi.fileTypes.FileTypeManager;
import dbhelp.plugin.idea.filetype.DiagramFileType;
import dbhelp.plugin.idea.filetype.DiagramEditor;
import org.jdom.Element;
import org.jetbrains.annotations.NonNls;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 20, 2006
 * Time: 10:53:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class DiagramFileTypeProvider implements ApplicationComponent, FileEditorProvider {
    public DiagramFileTypeProvider() {
    }

    public void initComponent() {
        FileTypeManager ftm = FileTypeManager.getInstance();
        ftm.registerFileType(new DiagramFileType(), new String[] {"dia"});
    }

    public void disposeComponent() {
        // TODO: insert component disposal logic here
    }

    public String getComponentName() {
        return "dbhelp.plugin.idea.DiagramFileTypeProvider";
    }

    public boolean accept(Project project, VirtualFile virtualFile) {
        return virtualFile.getFileType() instanceof DiagramFileType;
    }

    public FileEditor createEditor(Project project, VirtualFile virtualFile) {
        return new DiagramEditor();
    }

    public void disposeEditor(FileEditor fileEditor) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public FileEditorState readState(Element element, Project project, VirtualFile virtualFile) {
        return new FileEditorState() {
            public boolean canBeMergedWith(FileEditorState fileEditorState, FileEditorStateLevel fileEditorStateLevel) {
                return false;
            }
        };
    }

    public void writeState(FileEditorState fileEditorState, Project project, Element element) {
    }

    @NonNls
    public String getEditorTypeId() {
        return "Diagram";
    }

    public FileEditorPolicy getPolicy() {
        return FileEditorPolicy.HIDE_DEFAULT_EDITOR;
    }
}
