package dbhelp.plugin.idea.action;

import com.intellij.openapi.actionSystem.AnActionEvent;
import dbhelp.db.Table;
import dbhelp.plugin.complete.AbstractCompleteWindow;
import dbhelp.plugin.complete.utils.CompleterItem;
import dbhelp.plugin.idea.utils.IDEAUtils;
import utils.Utils;

import java.util.List;

/**
 * User: huojun
 * Date: 14-Sep-2006
 * Time: 10:17:00 AM
 */
public class ActionCompleteTable extends AbstractCompleteAction {
    protected void handleEvent(AnActionEvent e) {
        try {
            List<Table> tables = getDatabase().getMetaData().getAllTables();
            AbstractCompleteWindow cw = getCompleteWindow();
            cw.setItems(CompleterItem.listToItems(tables, CompleterItem.TableItem.class));
            CharSequence completingWord = IDEAUtils.getCompletingWord(getEditor());
            cw.setFilter(completingWord == null ? null : completingWord.toString());
            cw.showCompleter();
        } catch (IllegalStateException e1) {
            Utils.debug(e1);
            // trying to complete in ignored tokens such as comments and strings
        } catch (Exception e1) {
            e1.printStackTrace();
        }
    }

}
