package dbhelp.plugin.idea.action;

import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.editor.Editor;
import dbhelp.db.Database;
import dbhelp.db.SQLCommander;
import dbhelp.plugin.idea.utils.IDEAUtils;
import dbhelp.plugin.OutputPane;
import utils.Utils;

/**
 * User: huojun
 * Date: 13-Sep-2006
 * Time: 6:14:15 PM
 */
public class ActionRunSql extends BaseAction {

    public void actionPerformed(AnActionEvent e) {
        if (isSQLFile(e)) {
            try {
                Editor editor = getEditor();
                String selectedText = editor.getSelectionModel().getSelectedText();
                String sql = Utils.hasValue(selectedText) ? selectedText : editor.getDocument().getText();
                Database database = getDatabase();
                if (null != database) {
                    SQLCommander.runSQLCommand(database, sql, null, OutputPane.getOutputPane());
                } else {
                    IDEAUtils.chooseDatabase(editor.getDocument());
                }
            } catch (Exception e1) {
                Utils.error(e1);
            }
        }
    }


}
