package dbhelp.plugin.idea.action;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.actionSystem.DataConstants;
import com.intellij.openapi.actionSystem.DataContext;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.vfs.VirtualFile;
import dbhelp.db.Database;
import dbhelp.plugin.idea.complete.CompleteWindow;
import dbhelp.plugin.complete.AbstractCompleteWindow;
import dbhelp.plugin.idea.utils.IDEAUtils;
import dbhelp.plugin.idea.utils.Keys;

import javax.swing.*;

/**
 * User: huojun
 * Date: 13-Sep-2006
 * Time: 6:15:59 PM
 */
public abstract class BaseAction extends AnAction {

    protected BaseAction() {
    }

    protected BaseAction(String string) {
        super(string);
    }

    protected BaseAction(String string, String string1, Icon icon) {
        super(string, string1, icon);
    }

    public static VirtualFile getVirtualFile(AnActionEvent event) {
        DataContext dc = event.getDataContext();
        return (VirtualFile) dc.getData(DataConstants.VIRTUAL_FILE);
    }

    public static boolean isSQLFile(AnActionEvent e) {
        VirtualFile vf = getVirtualFile(e);
        return vf != null && vf.getName().toLowerCase().endsWith(".sql");
    }


    protected AbstractCompleteWindow getCompleteWindow() {
        return CompleteWindow.getInstance();
    }

    protected Database getDatabase() {
        Database database = getEditor().getDocument().getUserData(Keys.KEY_DATABASE);
        if( null == database ) {

        }
        return database;
    }

    protected static Editor getEditor() {
        return IDEAUtils.getActiveEditor();
    }

}
