package dbhelp.plugin.idea.action;

import com.intellij.openapi.fileEditor.FileEditor;
import com.intellij.openapi.fileEditor.FileEditorManager;
import dbhelp.plugin.idea.filetype.DiagramEditor;
import dbhelp.plugin.idea.utils.IDEAUtils;
import dbhelp.plugin.action.portable.TableAction;
import utils.Utils;

import java.awt.event.ActionEvent;

import diagram.shape.AbstractShape;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 22, 2006
 * Time: 2:08:05 PM
 */
public class FindTableInDiagram extends TableAction {

    public FindTableInDiagram() {
        super("Find Table in Diagram");
    }

    public void actionPerformed(ActionEvent e) {
        FileEditorManager fem = FileEditorManager.getInstance(IDEAUtils.getProject());
        for (FileEditor ed : fem.getAllEditors()) {
            if (ed instanceof DiagramEditor) {
                DiagramEditor de = (DiagramEditor) ed;
                AbstractShape s = de.getDiagram().getDiagram().getShape(getTable());
                if (null != s) {
                    de.getDiagram().sureVisible(getTable());
                    return;
                }
            }
        }
        Utils.message(getTable() + " is not included in any diagram!");
    }
}
