package dbhelp.plugin.idea.action;

import com.intellij.openapi.vfs.VirtualFile;
import dbhelp.db.Database;
import dbhelp.db.Procedure;
import dbhelp.plugin.action.portable.PortableAction;
import dbhelp.plugin.idea.utils.IDEAUtils;
import org.apache.velocity.VelocityContext;
import template.TemplateManager;
import utils.Utils;

import java.awt.event.ActionEvent;
import java.io.StringReader;
import java.io.StringWriter;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 25, 2006
 * Time: 11:57:51 AM
 */
public class ViewProcedureSyntax extends PortableAction {
    public ViewProcedureSyntax() {
        super("View Syntax");
    }

    public void actionPerformed(ActionEvent e) {
        Procedure p = (Procedure) getUserData();
        Database database = p.getDatabase();
        String query = database.getProcedureSyntaxQuery();
        if (Utils.hasValue(query)) {
            try {
                StringWriter out = new StringWriter();
                StringReader in = new StringReader(query);
                VelocityContext c = new VelocityContext();
                c.put("name", p);
                c.put("target", p);
                String name = p.toString();
                if( TemplateManager.getMgr().runTemplate(c, out, in) ) {
                    String queryCmd = out.toString();
                    String text = database.getMetaData().getProcedureSyntax(queryCmd);
                    StringReader data = new StringReader(text);
                    VirtualFile vf = IDEAUtils.createTempVirtualFile(name.replaceAll("\"", "") + ".sql", data);
                    IDEAUtils.openEditor(vf);
                }
            } catch (Exception e1) {
                Utils.error(e1);
            }
        }
    }
}
