package dbhelp.plugin.idea.action;

import dbhelp.db.Table;
import dbhelp.plugin.idea.ui.IDEADiagramPainter;
import dbhelp.plugin.ui.DatabaseDiagramPainter;
import dbhelp.plugin.action.portable.PortableAction;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 22, 2006
 * Time: 6:55:07 PM
 */
public class ViewTablesDiagram extends PortableAction {

    public ViewTablesDiagram() {
        super("View Tables Diagram");
    }

    public Table[] getTables() {
        return (Table[]) getValue("userdata");
    }

    public void actionPerformed(ActionEvent e) {
        Table[] theTables = getTables();
        if (null != theTables) {
            Boolean b = DatabaseDiagramPainter.askPaintOptions();
            if ( null != b ) {
                final DatabaseDiagramPainter w = new IDEADiagramPainter(theTables);
                w.setAutoAddRefTables(b);
                Runnable runnable = new Runnable() {
                    public void run() {
                        w.layoutTables();
                    }
                };
                SwingUtilities.invokeLater(runnable);
            }
        }
    }
}
