package dbhelp.plugin.idea.highlight;

import bean.PropertyChangeMultiCaster;
import com.intellij.ide.highlighter.custom.SyntaxTable;
import dbhelp.db.Database;
import dbhelp.plugin.idea.SQLFileTypeSupport;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Sep 19, 2006
 * Time: 11:38:44 PM
 */
public class SQLSyntaxTable extends SyntaxTable {
    private Set<String> _keywordList = new HashSet<String>(Database.SQL92_KEYWORD_LIST);

    public SQLSyntaxTable() {
        super();
        setEndComment("*/");
        setStartComment("/*");
        setHexPrefix("0x");
        setIgnoreCase(true);
        setLineComment("--");
        setHasParens(true);
        setNumPostfixChars("");
        PropertyChangeMultiCaster.getInstance().addListener(SQLFileTypeSupport.SQLLexer.class
                , new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                if ("database".equals(evt.getPropertyName())) {
                    SQLFileTypeSupport.SQLLexer lexer = (SQLFileTypeSupport.SQLLexer) evt.getSource();
                    synchronized (this) {
                        _keywordList.addAll( lexer.getKeywords() );                        
                    }
                }
            }
        });
    }
    
    public synchronized Set<String> getKeywords1() {
        return _keywordList;
    }

}
