package dbhelp.plugin.idea.ui;

import com.intellij.openapi.fileEditor.FileEditor;
import com.intellij.openapi.vfs.VirtualFile;
import dbhelp.db.Database;
import dbhelp.db.Table;
import dbhelp.plugin.idea.filetype.DiagramEditor;
import dbhelp.plugin.idea.utils.IDEAUtils;
import dbhelp.plugin.ui.DatabaseDiagram;
import dbhelp.plugin.ui.DatabaseDiagramPainter;

import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 27-Mar-2006
 * Time: 2:57:26 PM
 */
public class IDEADiagramPainter extends DatabaseDiagramPainter {

    public IDEADiagramPainter(Table[] tables) {
        super(tables);
    }


    protected DatabaseDiagram getDiagram(Database database) throws Exception {
        String schemaFileName = getFileName(database) + ".dia";
        VirtualFile vf = IDEAUtils.createTempVirtualFile(schemaFileName, null);
        FileEditor[] fileEditors = IDEAUtils.openEditor(vf);
        if (fileEditors != null && fileEditors.length > 0) {
            if (fileEditors[0] instanceof DiagramEditor) {
                DiagramEditor de = (DiagramEditor) fileEditors[0];
                File value = new File(vf.getPath());
                DatabaseDiagram diagram = de.getDiagram();
                diagram.setDatabase(database);
                diagram.setFile(value);
                return diagram;
            }
        }
        return null;
    }

    private String getFileName(Database database) {
        String name = database.getUrl().replaceAll("[^\\w]", "_");
        return name.length() > 40 ? name.substring(0, 40) : name;
    }

}
