package dbhelp.plugin.ui;

import dbhelp.db.Database;
import utils.Config;

import javax.swing.*;
import java.awt.*;
import static java.awt.GridBagConstraints.*;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/**
 * User: David Huo
 * Date: Sep 19, 2006
 * Time: 8:23:53 PM
 */
public class ChooseDatabaseDialog extends QuickCloseDialog {
    private Database _database;
    protected boolean _confirmed;
    private JList _list = new JList(Config.getConfig().getDatabases());

    public ChooseDatabaseDialog(Frame owner) throws HeadlessException {
        super(owner);
        setModal(true);
        setTitle("Choose Database");
        setLayout(new GridBagLayout());
        GridBagConstraints c;
        c = new GridBagConstraints(0, 0, 1, 1, 1, 1, NORTH, BOTH, new Insets(2, 2, 2, 2), 0, 0);
        add(new JScrollPane(_list), c);
        c = new GridBagConstraints(0, 1, 1, 1, 0, 0, SOUTHEAST, NONE, new Insets(2, 2, 2, 2), 0, 0);
        JButton jbOk = new JButton(new actionClose("OK"));
        add(jbOk, c);
        jbOk.setMnemonic('O');
        _list.setSelectedIndex(0);
        setDefaultButton(jbOk);
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        setLocationRelativeTo(null);
        setSize(320, 260);
        _list.addMouseListener( new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                int index = _list.getSelectedIndex();
                if( e.getClickCount() == 2 && index >= 0 ) {
                    setDatabase();
                }
            }
        });
    }

    public void setVisible(boolean b) {
        if (b) {
            _confirmed = false;
        }
        super.setVisible(b);
    }

    public boolean isConfirmed() {
        return _confirmed;
    }

    protected void enter() {
        setDatabase();
    }

    private void setDatabase() {
        _database = (Database) _list.getSelectedValue();
        _confirmed = true;
        setVisible(false);
    }

    private class actionClose extends AbstractAction {
        public actionClose(String name) {
            super(name);
        }

        public void actionPerformed(ActionEvent e) {
            setDatabase();
        }
    }

    public Database getDatabase() {
        return _database;
    }
}
