package dbhelp.plugin.ui;

import utils.Utils;

import javax.swing.*;
import java.awt.*;
import java.awt.event.KeyEvent;

/**
 * User: huojun
 * Date: 25-Oct-2006
 * Time: 9:53:08 AM
 */
public class PopupWindow extends JPanel {
    protected JLayeredPane _pane;

    public PopupWindow() {
        super(new BorderLayout() );
        setVisible(false);
    }

    protected JLayeredPane getLayeredPane() {
        Component c = Utils.getFrame();
        if (c instanceof JFrame) {
            return ((JFrame) c).getLayeredPane();
        } else if (c instanceof JDialog) {
            return ((JDialog) c).getLayeredPane();
        }
        return null;
    }


    protected void processKeyEvent(KeyEvent e) {
        System.out.println("PopupWindow.processKeyEvent");
        super.processKeyEvent(e);
    }

    public void popup(Component src, Point p) {
        JLayeredPane pane = getLayeredPane();
        if( null != pane ) {
            Point point = SwingUtilities.convertPoint(src, p, pane);
            _pane = pane;
            _pane.add( this, JLayeredPane.POPUP_LAYER );
            setLocation( point );
            setVisible( true );
        }
    }

    public void close() {
        if( isVisible() ) {
            if( null != _pane ) {
                setVisible( false );
                _pane.remove(this);
                putClientProperty(JLayeredPane.LAYER_PROPERTY, null);
            }
        }
    }
}
