package diagram;

import diagram.shape.AbstractShape;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 17-Feb-2006
 * Time: 10:59:00 AM
 */
class DragImage extends JComponent {
    private AbstractShape _shape;
    private Image _image;

    public AbstractShape getShape() {
        return _shape;
    }

    public void setShape(AbstractShape shape) {
        _shape = shape;
        setSize(_shape.getSize());
        setLocation(_shape.getLocation());
        if (!(_shape instanceof ICanDrawDragIcon) ) {
            // not a line kind shape
            _image = new BufferedImage(_shape.getWidth(), _shape.getHeight(), BufferedImage.TYPE_BYTE_BINARY);
            Graphics g = _image.getGraphics();
            g.translate(-_shape.getX(), -_shape.getY());
            _shape.paintDragImage(g);
        }
    }

    public void beginDrag() {
        if (!isVisible()) {
            setVisible(true);
        }
    }

    public void stopDrag() {
        _shape.setLocation(getLocation());
        setVisible(false);
        _shape.fireShapeChangeEvent();
    }

    protected void paintComponent(Graphics g) {
        if (!(_shape instanceof ICanDrawDragIcon)) {
            g.drawImage(_image, 0, 0, this);
        } else {
            g.translate(-_shape.getX(), -_shape.getY());
            _shape.paintDragImage(g);
        }
    }
}
