package diagram;

import dbhelp.plugin.action.portable.PopupMouseAdapter;
import diagram.shape.AbstractShape;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 12-Aug-2005
 * Time: 9:51:51 AM
 */
public class ShapeContainer extends JComponent {
    private diagram.shape.AbstractShape _shape;

    public ShapeContainer() {
    }

    public ShapeContainer(diagram.shape.AbstractShape shape) {
        setShape(shape);        
    }

    public AbstractShape getShape() {
        return _shape;
    }

    public void setShape(AbstractShape shape) {
        _shape = shape;
        _shape.setContainer(this);
        addMouseListener(new MyPopupMouseAdapter(_shape));
        adjust();
    }

    public void adjust() {
        Rectangle b = _shape.getBounds();
        setSize(b.width + 2 * Handle.SIZE, b.height + 2 * Handle.SIZE);
        setLocation(b.x - Handle.SIZE, b.y - Handle.SIZE);
    }

    protected void paintHandles(Graphics g) {
        Color c = g.getColor();
        Handle[] handles = _shape.getHandles();
        g.setColor(Color.black);
        for (int i = 0; null != handles && i < handles.length; i++) {
            Handle h = handles[i];
            Rectangle b = h.getBounds();
            g.fillRect(b.x, b.y, b.width, b.height);
        }
        g.setColor(c);
    }

    protected void paintComponent(Graphics g) {
//        g.drawRect(0,0, getWidth()-1, getHeight()-1);
        Rectangle b = _shape.getBounds();
        g = g.create();
        g.translate(-b.x + Handle.SIZE, -b.y + Handle.SIZE);
        getShape().paint(g);
        if (getShape().isSelected()) {
            paintHandles(g);
        }
//        g.translate(0,0);
    }

    public String toString() {
        return _shape.getClass().toString();
    }

    private static class MyPopupMouseAdapter extends PopupMouseAdapter {
        private AbstractShape _shape;

        public MyPopupMouseAdapter(AbstractShape shape) {
            _shape = shape;
        }

        protected Set<Object> getActionKeys(MouseEvent e) {
            Set<Object> actions = new HashSet<Object>();
            actions.add(_shape);
            Object object = _shape.getObject();
            if( null != object ) {
                actions.add(object);
            }
            return actions;
        }
    }
}
