package diagram;

import java.awt.geom.Point2D;
import java.awt.geom.Line2D;
import java.awt.geom.PathIterator;
import java.awt.*;
import java.awt.event.MouseEvent;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 11-Aug-2005
 * Time: 3:35:24 PM
 */
public class Utilities {
    public static Point getIntersectionPoint(Shape s, Point p) {
        return getIntersectionPoint(s, p, getCenter(s));
    }

    public static Point getIntersectionPoint(Shape s, Point p, Point p1) {
        PathIterator pi = s.getPathIterator(null);
        double[] coordinates = new double[6];
        Double x = null;
        Double y = null;
        while ( !pi.isDone() ) {
            int type = pi.currentSegment(coordinates);
            switch (type) {
                case PathIterator.SEG_MOVETO:
        //                    Utils.debug("move to " + coordinates[0] + ", " + coordinates[1]);
                    x = coordinates[0];
                    y = coordinates[1];
                    break;
                case PathIterator.SEG_LINETO:
        //                    Utils.debug("line to " + coordinates[0] + ", " + coordinates[1]);
                    if( null != x ) {
                        Line2D.Float l1 = new Line2D.Float(x.floatValue(), y.floatValue(),
                                (float)coordinates[0], (float)coordinates[1]);
                        Line2D.Float l2 = new Line2D.Float(p, p1);
                        Point2D.Float point = getIntersectionPoint(l1, l2);
                        if( null != point ) {
                            return new Point((int) point.x, (int) point.y);
                        }
                    }
                    x = coordinates[0];
                    y = coordinates[1];
                    break;
                case PathIterator.SEG_CLOSE:
        //                    Utils.debug("Close");
                default:
                    y = x = null;
                    break;
            }
            pi.next();
        }
        return null;
    }

    private static Point getCenter(Shape s) {
        Rectangle b = s.getBounds();
        return new Point(b.x + b.width / 2, b.y + b.height / 2);
    }

    public static Point2D.Float getIntersectionPoint(Line2D.Float line1, Line2D.Float line2) {
        if (!line1.intersectsLine(line2)) return null;
        double px = line1.getX1();
        double py = line1.getY1();
        double rx = line1.getX2() - px;
        double ry = line1.getY2() - py;
        double qx = line2.getX1();
        double qy = line2.getY1();
        double sx = line2.getX2() - qx;
        double sy = line2.getY2() - qy;
        double det = sx * ry - sy * rx;
        if (det == 0) {
            return null;
        } else {
            double z = (sx * (qy - py) + sy * (px - qx)) / det;
            if (z == 0 || z == 1) return null;  // intersection at end point!
            return new Point2D.Float((float) (px + z * rx), (float) (py + z * ry));
        }
    } // end intersection line-line

    public static boolean isActionButton(MouseEvent e) {
        return e.getButton() == MouseEvent.BUTTON1;
    }
}
