package diagram.shape;

import diagram.ShapeListener;
import diagram.DiagramViewer;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 12-Aug-2005
 * Time: 4:28:02 PM
 */
public class ArrowGlue implements ShapeListener {
    private AbstractShape _shape1;
    private AbstractShape _shape2;
    private Arrow _arrow;
    private AbstractShape _shape;
    private DiagramViewer _diagram;

    public ArrowGlue(DiagramViewer diagram, Arrow arrow) {
        _diagram = diagram;
        _arrow = arrow;
        _arrow.addChangeListener(this);
    }

    public AbstractShape getShape() {
        return _shape;
    }

    public void setShape(AbstractShape shape) {
        _shape = shape;
    }

    public Arrow getArrow() {
        return _arrow;
    }

    public void shapeChanged(AbstractShape s) {
        if (getArrow().equals(s)) {
            AbstractShape s2 = _diagram.findShapeAtPoint(new Point(_arrow.getX2(), _arrow.getY2()), new AbstractShape[] {_arrow, _shape });
            AbstractShape s1 = _diagram.findShapeAtPoint(new Point(_arrow.getX1(), _arrow.getY1()), new AbstractShape[] {_arrow, _shape });
            if( s1 != null && s1.equals(s2) ) {
                return;
            }
            attachListener(s1, 0);
            attachListener(s2, 1);
            if( _shape != null ) {
                Point c = getArrow().getCenter();
                _shape.setLocation( c.x - _shape.getWidth() / 2,
                        c.y - _shape.getHeight() / 2);
                _shape.moveToFront();
            }
        } else {
            Point c;
            if (s.equals(_shape1)) {
                c = _shape1.getCenter();
                getArrow().setX1(c.x);
                getArrow().setY1(c.y);
            }
            if (s.equals(_shape2)) {
                c = _shape2.getCenter();
                getArrow().setX2(c.x);
                getArrow().setY2(c.y);
            }
        }
    }

    private void attachListener(AbstractShape foundShape, int id) {
        AbstractShape old = id == 0 ? _shape1 : _shape2;
        if (null != foundShape) {
            if (!foundShape.equals(old)) {
                if (null != old) {
                    old.removeChangeListener(this);
                }
            }
            if (id == 0) {
                _shape1 = foundShape;
                _shape1.addChangeListener(this);
            } else {
                _shape2 = foundShape;
                _shape2.addChangeListener(this);
            }

        } else {
            if (id == 0) {
                if (_shape1 != null) {
                    _shape1.removeChangeListener(this);
                }
                _shape1 = null;
            } else {
                if (_shape2 != null) {
                    _shape2.removeChangeListener(this);
                }
                _shape2 = null;
            }
        }
    }
}
