package diagram.shape;

import java.awt.*;
import java.awt.geom.Arc2D;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 12-Aug-2005
 * Time: 1:22:46 PM
 */
public class Circle extends Rect {
    private double _beginAngle = 0;
    private double _endAngle = 360;
    private Arc2D.Double _circle = new Arc2D.Double(0, 0, 100, 100, 0, 360, Arc2D.CHORD);

    public Rectangle getBounds() {
        return _circle.getBounds();
    }

    public boolean contains(Point p) {
        return _circle.contains(p);
    }

    public double getBeginAngle() {
        return _beginAngle;
    }

    public void setBeginAngle(double beginAngle) {
        _beginAngle = beginAngle;
        adjust();
        paintContainer();
    }

    public double getEndAngle() {
        return _endAngle;
    }

    public void setEndAngle(double endAngle) {
        _endAngle = endAngle;
        adjust();
        paintContainer();
    }

    public void setBounds(Rectangle r) {
        _circle.setArc(r.x, r.y, r.width, r.height, getBeginAngle(), getEndAngle(), Arc2D.CHORD);
        adjust();
        paintContainer();
    }

    public void paint(Graphics g) {
        g.setColor(getBackground());
        g.fillArc((int) _circle.x, (int) _circle.y,
                (int) _circle.width, (int) _circle.height, 0, 360);

        g.setColor(getForeground());
        g.drawArc((int) _circle.x, (int) _circle.y,
                (int) _circle.width, (int) _circle.height, (int) getBeginAngle(), (int) getEndAngle());
    }
}
