package diagram.shape.database;


import bean.annotation.Property;
import dbhelp.db.Column;
import dbhelp.db.ForeignKey;
import dbhelp.db.Table;
import diagram.shape.Link;
import diagram.shape.TextBox;

import java.awt.*;
import java.util.List;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * User: huojun
 * Date: 20-Feb-2006
 * Time: 4:01:27 PM
 */
public class TableBox extends TextBox {
    public TableBox() {
    }

    public TableBox(Table t) {
        setTable(t);
    }

    public Table getTable() {
        return (Table) getObject();
    }

    public void setTable(Table t) {
        setText(getTableText(t));
        Font f = new Font("Dialog", Font.PLAIN, 9);
        setFont(f);
        setBackground(new Color(166, 202, 220));
        setObject(t);
    }

    @Property(xmlAttr = false)
    public Object getObject() {
        return super.getObject();
    }

    public Dimension calulateSize() {
        super.calculateSize(null);
        return getSize();
    }

    public void remove() {
        List<Map.Entry> entries = _diagram.getValues(ForeignKey.class);
        for (Map.Entry e : entries) {
            Object o = e.getValue();
            if ( o instanceof Link ) {
                Link l = (Link) o;
                if (l.getBeginShape().equals(this) || l.getEndShape().equals(this)) {
                    l.getArrow().remove();
                    l.getText().remove();
                    _diagram.delete(e.getKey());
                }
            }
        }
        super.remove();
    }

    private String getTableText(Table t) {
        StringBuffer sb = new StringBuffer('[' + t.getName() + ']');
        Column[] cols = t.getColumns();
        for (Column col : cols) {
            sb.append('\n').append(col);
        }
        return sb.toString();
    }
}
