package utils.ui;

import utils.Icons;
import utils.Utils;

import javax.swing.*;
import java.awt.*;
import static java.awt.GridBagConstraints.*;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * Created by IntelliJ IDEA.
 * User: David Huo
 * Date: Oct 28, 2006
 * Time: 3:31:49 PM
 */
public class ErrorDialog extends JDialog {
    private JTextArea _view = new JTextArea();
    private JDialog _dialog = this;
    private JButton _cbOK = new JButton(new ActionClose());
    private JScrollPane _pane = new JScrollPane(_view);
    private JLabel _label = new JLabel();

    public static void main(String[] args) {
        try {
            throw new Exception("this is an error message!this is an error message!this is an error message!this is an error message!  ");
        } catch (Exception e) {
            Utils.error(e);
        }
    }

    public static void showDialog(String title, Throwable t) {
        Component frame = Utils.getFrame();

        if (t.toString().length() <= 60) {
            Utils.errorMsg(t);
            return;
        }
        StringWriter sw = new StringWriter();
        t.printStackTrace(new PrintWriter(sw));

        ErrorDialog d;
        String s = t.getMessage() == null ? t.toString() : t.getMessage();
        String trace = sw.toString();
        if (frame instanceof Frame || null == frame) {
            d = new ErrorDialog(((Frame) frame), s, trace);
        } else {
            d = new ErrorDialog(((Dialog) frame), s, trace);
        }
        d.setTitle(title);
        d.setLocationRelativeTo(null);
        d.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        d.setVisible(true);
    }

    public ErrorDialog(Frame frame, String shortMessage, String detailMessage) throws HeadlessException {
        super(frame);
        initComponents(shortMessage, detailMessage);
    }

    public ErrorDialog(Dialog dialog, String shortMessage,  String detailMessage) throws HeadlessException {
        super(dialog);
        initComponents(shortMessage, detailMessage);
    }

    private void initComponents(String shortMessage, String text) {
        Container c = getContentPane();
        c.setLayout(new GridBagLayout());
        _view.setEditable(false);
        _view.setBackground(Color.white);
        JPanel topPane = new JPanel(new BorderLayout() );
        GridBagConstraints g;
        _label.setIcon( Icons.getInstance().get(26));
        String s = shortMessage.length() > 200 ? shortMessage.substring(0, 200) + "..." : shortMessage;
        s = s.replaceAll("<", "&lt;").replaceAll(">", "&gt;");
        _label.setText("<html><body>" + s + "</body></html>");
        g = new GridBagConstraints(0, 0, 1, 1, 1, 0, NORTHWEST, HORIZONTAL, new Insets(10, 10, 2, 4), 1, 1);
        topPane.add(_label, BorderLayout.CENTER);
        topPane.add(_cbOK, BorderLayout.EAST);
        c.add(topPane, g);
        g = new GridBagConstraints(0, 1, 2, 1, 1, 1, NORTHWEST, BOTH, new Insets(10, 10, 4, 10), 1, 1);
        c.add(_pane, g);
        _pane.setBorder( BorderFactory.createTitledBorder("Detail message"));
        _view.setText(text);
        _view.setEditable(false);
//        g = new GridBagConstraints(1, 0, 1, 1, 1, 0, EAST, NONE, new Insets(2, 2, 2, 10), 1, 1);
//        c.add(_cbOK, g);
        setSize(480, 280);
        setModal(true);
        setResizable(false);

        Utils.addEscClose(_dialog);
    }

    private class ActionClose extends AbstractAction {

        public ActionClose() {
            super("OK");
            putValue(AbstractAction.MNEMONIC_KEY, KeyEvent.VK_O);
        }

        public void actionPerformed(ActionEvent e) {
            _dialog.setVisible(false);
            _dialog.dispose();
        }
    }
}
